package bookExamples.ch26Graphics.draw2d;

import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * User: Keith Shaffer
 * Date: Feb 3, 2005
 * Time: 6:21:16 PM
 * To change this template use File | Settings | File Templates.
 */
public class RtTriangle2d extends DJShape {

    int h = 1;
    int w = 1;
    int xc = 0;
    int yc = 0;

    public DJShape getInstance(int x1, int y1, int x2, int y2) {
        return new bookExamples.ch26Graphics.draw2d.RtTriangle2d(x1, y1, x2, y2);
    }

    public int getX1() {
        return x1;
    }

    public int getY1() {
        return y1;
    }

    public int getW() {
        return w;
    }

    public int getH() {
        return h;
    }


    public RtTriangle2d(int _x1, int _y1, int _x2, int _y2) {
        super(_x1, _y1, _x2, _y2);
        setX1(_x1);
        setY1(_y1);
        w = Math.abs(_x2 - x1);
        h = Math.abs(_y2 - y1);
        if (_x1 > _x2) setX1(_x2);
        if (_y1 > _y2) setY1(_y2);
        xc = x1 + w / 2;
        yc = y1 + h / 2;

    }

    public static void drawTriangle(int x, int y, int width, int height, Graphics g) {
        if ((width < 0) || (height < 0)) {
            return;
        }

        if (height == 0 || width == 0) {
            g.drawLine(x, y, x + width, y + height);
        } else {


            g.drawLine(x, y + height, x, y + 1);
            g.drawLine(x, y, x + width - 1, y);
            g.drawLine(x, y + height, x + width + 1, y - 1);
        }
    }

    public void draw(Graphics g) {
        drawTriangle(x1, y1, w, h, g);
        g.fillOval(xc, yc, 2, 2);
        g.drawString("(" + xc + "," + yc + ")", xc + 3, yc + 3);
    }


}
